;;; -*- lisp -*-

;;; `defpatt' - A package for defining PPCREs for the `cl-ppcre' package
;;;             by Dr. Edi Weitz.

;;;
;;; Copyright (c) 2004, Klaus Harbo.   All rights reserved.
;;;

;;; Redistribution and use in source and binary forms, with or without
;;; modification, are permitted provided that the following conditions
;;; are met:

;;;   * Redistributions of source code must retain the above copyright
;;;     notice, this list of conditions and the following disclaimer.

;;;   * Redistributions in binary form must reproduce the above
;;;     copyright notice, this list of conditions and the following
;;;     disclaimer in the documentation and/or other materials
;;;     provided with the distribution.

;;; THIS SOFTWARE IS PROVIDED BY THE AUTHOR 'AS IS' AND ANY EXPRESSED
;;; OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
;;; WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
;;; ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
;;; DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
;;; DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
;;; GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
;;; INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
;;; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
;;; NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
;;; SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

(in-package :common-lisp-user)

(defpackage #:defpatt
  (:use :cl :cl-ppcre)
  (:export
   #:defpatt
   #:defpatt-initialize
   #:defpatt-initialize-abstractions
   #:defpatt-pattern
   #:defpatt-set-default-macro-char
   #:defpatt-set-dispatch-macro-char
   #:defpatt-set-macro-char

   ;; Defpatt Abstractions
   #:**
   #:++
   #:??
   #:alt
   #:digit
   #:digit*
   #:digit+
   #:group
   #:reg
   #:rep
   #:re
   #:seq
   #:upto
   #:upto+
   #:ws
   #:ws*
   #:ws+

#| The more `defpatt' abstractions are available, the more useful
   `defpatt' will be.  Contributions are gratefully accepted - 
   please e-mail the `defpatt' maintainer (cf. ./defpatt.asd)
|#
   ))

